

module main(
	input clkin,
	inout [5:0]gpio,
	output SCK,
	output MOSI,
	input  MISO,
	output SS,
	output SS2,
	output SS3,

	output txd,
	input rxd,

	output pwmp,
	output pwmn,

	inout [15:0]XD,
	output [15:0]XA,
	output XWE,
	output XOE,
	output XBHE,
	output XBLE,

	output resb
);
wire XBHE;
wire XBLE;
assign XBHE=0;
assign XBLE=0;

wire clk;
//-- Instanciar el PLL
pll
  pll1(
	.clock_in(clkin),
	.clock_out(clk),
	.locked(pll_lock)
	);

// Reset
reg [19:0]cres=20'h0;
always @(posedge clkin) cres<=cres[19]?cres:cres+1;
assign resb=cres[19];

SYSTEM sys1(.txd(txd), .rxd(rxd), .clk(clk), .resb(resb), .gpo(gpo), .gpdir(gpdir), .gpi(gpi),
	.SCK(SCK), .MOSI(MOSI), .MISO(MISO), .SSB(SSB), .pwmp(pwmp), .pwmn(pwmn), .eintb(eintb), 
	.exwe(XWE), .exoe(XOE), .exdo(exdo), .exdin(exdin), .exaddr(XA) );


wire [15:0]gpo;
wire [15:0]gpdir;
wire [15:0]gpi;
wire eintb;
wire SCK, MOSI, MISO;
wire [3:1]SSB;
assign SS=SSB[1];
assign SS2=SSB[2];
assign SS3=SSB[3];
wire [15:0]exdin;
wire [15:0]exdo;
wire pwm;

// Provisional...
assign eintb=1'b1;

// Triestados de GPIO

SB_IO #( .PIN_TYPE(6'b 1010_01), .PULLUP(1'b 0) ) io_block_instance0
(   .PACKAGE_PIN(   gpio[0]),
    .OUTPUT_ENABLE(gpdir[0]),
    .D_OUT_0(        gpo[0]),
    .D_IN_0(         gpi[0])  );
SB_IO #( .PIN_TYPE(6'b 1010_01), .PULLUP(1'b 0) ) io_block_instance1
(   .PACKAGE_PIN(   gpio[1]),
    .OUTPUT_ENABLE(gpdir[1]),
    .D_OUT_0(        gpo[1]),
    .D_IN_0(         gpi[1])  );
SB_IO #( .PIN_TYPE(6'b 1010_01), .PULLUP(1'b 0) ) io_block_instance2
(   .PACKAGE_PIN(   gpio[2]),
    .OUTPUT_ENABLE(gpdir[2]),
    .D_OUT_0(        gpo[2]),
    .D_IN_0(         gpi[2])  );
SB_IO #( .PIN_TYPE(6'b 1010_01), .PULLUP(1'b 0) ) io_block_instance3
(   .PACKAGE_PIN(   gpio[3]),
    .OUTPUT_ENABLE(gpdir[3]),
    .D_OUT_0(        gpo[3]),
    .D_IN_0(         gpi[3])  );
SB_IO #( .PIN_TYPE(6'b 1010_01), .PULLUP(1'b 0) ) io_block_instance4
(   .PACKAGE_PIN(   gpio[4]),
    .OUTPUT_ENABLE(gpdir[4]),
    .D_OUT_0(        gpo[4]),
    .D_IN_0(         gpi[4])  );
SB_IO #( .PIN_TYPE(6'b 1010_01), .PULLUP(1'b 0) ) io_block_instance5
(   .PACKAGE_PIN(   gpio[5]),
    .OUTPUT_ENABLE(gpdir[5]),
    .D_OUT_0(        gpo[5]),
    .D_IN_0(         gpi[5])  );

// Triestados de memoria externa
wire oe;
assign oe=XOE;

SB_IO #( .PIN_TYPE(6'b 1010_01), .PULLUP(1'b 0) ) xd_instance0
(   .PACKAGE_PIN(   XD[0]),
    .OUTPUT_ENABLE( oe   ),
    .D_OUT_0(       exdo[0]),
    .D_IN_0(       exdin[0]) );
SB_IO #( .PIN_TYPE(6'b 1010_01), .PULLUP(1'b 0) ) xd_instance1
(   .PACKAGE_PIN(   XD[1]),
    .OUTPUT_ENABLE( oe   ),
    .D_OUT_0(       exdo[1]),
    .D_IN_0(       exdin[1]) );
SB_IO #( .PIN_TYPE(6'b 1010_01), .PULLUP(1'b 0) ) xd_instance2
(   .PACKAGE_PIN(   XD[2]),
    .OUTPUT_ENABLE( oe   ),
    .D_OUT_0(       exdo[2]),
    .D_IN_0(       exdin[2]) );
SB_IO #( .PIN_TYPE(6'b 1010_01), .PULLUP(1'b 0) ) xd_instance3
(   .PACKAGE_PIN(   XD[3]),
    .OUTPUT_ENABLE( oe   ),
    .D_OUT_0(       exdo[3]),
    .D_IN_0(       exdin[3]) );
SB_IO #( .PIN_TYPE(6'b 1010_01), .PULLUP(1'b 0) ) xd_instance4
(   .PACKAGE_PIN(   XD[4]),
    .OUTPUT_ENABLE( oe   ),
    .D_OUT_0(       exdo[4]),
    .D_IN_0(       exdin[4]) );
SB_IO #( .PIN_TYPE(6'b 1010_01), .PULLUP(1'b 0) ) xd_instance5
(   .PACKAGE_PIN(   XD[5]),
    .OUTPUT_ENABLE( oe   ),
    .D_OUT_0(       exdo[5]),
    .D_IN_0(       exdin[5]) );
SB_IO #( .PIN_TYPE(6'b 1010_01), .PULLUP(1'b 0) ) xd_instance6
(   .PACKAGE_PIN(   XD[6]),
    .OUTPUT_ENABLE( oe   ),
    .D_OUT_0(       exdo[6]),
    .D_IN_0(       exdin[6]) );
SB_IO #( .PIN_TYPE(6'b 1010_01), .PULLUP(1'b 0) ) xd_instance7
(   .PACKAGE_PIN(   XD[7]),
    .OUTPUT_ENABLE( oe   ),
    .D_OUT_0(       exdo[7]),
    .D_IN_0(       exdin[7]) );
SB_IO #( .PIN_TYPE(6'b 1010_01), .PULLUP(1'b 0) ) xd_instance8
(   .PACKAGE_PIN(   XD[8]),
    .OUTPUT_ENABLE( oe   ),
    .D_OUT_0(       exdo[8]),
    .D_IN_0(       exdin[8]) );
SB_IO #( .PIN_TYPE(6'b 1010_01), .PULLUP(1'b 0) ) xd_instance9
(   .PACKAGE_PIN(   XD[9]),
    .OUTPUT_ENABLE( oe   ),
    .D_OUT_0(       exdo[9]),
    .D_IN_0(       exdin[9]) );
SB_IO #( .PIN_TYPE(6'b 1010_01), .PULLUP(1'b 0) ) xd_instance10
(   .PACKAGE_PIN(   XD[10]),
    .OUTPUT_ENABLE( oe   ),
    .D_OUT_0(       exdo[10]),
    .D_IN_0(       exdin[10]) );
SB_IO #( .PIN_TYPE(6'b 1010_01), .PULLUP(1'b 0) ) xd_instance11
(   .PACKAGE_PIN(   XD[11]),
    .OUTPUT_ENABLE( oe   ),
    .D_OUT_0(       exdo[11]),
    .D_IN_0(       exdin[11]) );
SB_IO #( .PIN_TYPE(6'b 1010_01), .PULLUP(1'b 0) ) xd_instance12
(   .PACKAGE_PIN(   XD[12]),
    .OUTPUT_ENABLE( oe   ),
    .D_OUT_0(       exdo[12]),
    .D_IN_0(       exdin[12]) );
SB_IO #( .PIN_TYPE(6'b 1010_01), .PULLUP(1'b 0) ) xd_instance13
(   .PACKAGE_PIN(   XD[13]),
    .OUTPUT_ENABLE( oe   ),
    .D_OUT_0(       exdo[13]),
    .D_IN_0(       exdin[13]) );
SB_IO #( .PIN_TYPE(6'b 1010_01), .PULLUP(1'b 0) ) xd_instance14
(   .PACKAGE_PIN(   XD[14]),
    .OUTPUT_ENABLE( oe   ),
    .D_OUT_0(       exdo[14]),
    .D_IN_0(       exdin[14]) );
SB_IO #( .PIN_TYPE(6'b 1010_01), .PULLUP(1'b 0) ) xd_instance15
(   .PACKAGE_PIN(   XD[15]),
    .OUTPUT_ENABLE( oe   ),
    .D_OUT_0(       exdo[15]),
    .D_IN_0(       exdin[15]) );


endmodule


