//-------------------------------------------------------------------
//-- counter4_tb.v
//-- Banco de pruebas para el contador de 4 bits con prescaler
//-------------------------------------------------------------------
//-- BQ August 2015. Written by Juan Gonzalez (Obijuan)
//-------------------------------------------------------------------

module tb();

//-- Registros con señales de entrada
reg clk;
reg resetb;
wire txd;

wire [15:0]gpo;
reg  [15:0]gpi;
reg      eintb;

reg MISO;
wire SCK, MOSI;
wire [3:1]SSB;

reg  [15:0]exdin;
wire [15:0]exdo;
wire [15:0]exaddr;
wire exwe;
wire exoe;

//-- Instanciamos 

SYSTEM sys1(.txd(txd), .rxd(rxd), .clk(clk), .resb(resetb), .gpo(gpo), .gpdir(gpdir), .gpi(gpi),
	.SCK(SCK), .MOSI(MOSI), .MISO(MISO), .SSB(SSB), .eintb(eintb), 
	.exwe(exwe), .exoe(exoe), .exdo(exdo), .exdin(exdin), .exaddr(exaddr));

// Reloj periódico
always #5 clk=~clk;

//-- Proceso al inicio
initial begin
	//-- Fichero donde almacenar los resultados
	$dumpfile("tb.vcd");
	$dumpvars(0, tb);

	resetb = 0; clk=0; 
	gpi=16'h0000;
	eintb=1'b1;
	MISO=0;
	exdin=16'haa55;

	#7		resetb=1;
	#690 MISO=1;
	//# 319 $display("FIN de la simulacion");
	# 300000 $finish;
	//# 1000 $finish;
end



endmodule


